import java.awt.*;
import java.util.*;
import java.applet.*;
import java.awt.event.*;

public class TetrisApplet extends Applet implements KeyListener,TimerListener {

  Graphics graphics;
  static TextField textField;
  static Timer timer;

  static int score=0;
  static int point=0;
  static int tid=0;
  static int sek=0;
  static boolean start=true;

  final static int DELAY = 300;
  final static int D=10;
  final static int HEIGHT=280;
  final static int WIDTH=100;
  final static int xmin = 0;
  final static int xmax = WIDTH/D-1;
  final static int ymin = 0;
  final static int ymax = HEIGHT/D-1;

  static int[][] felt = new int[ymax+1][xmax+1] ;

  static int[] x1 = {0,0,1,2,3};
  static int[] y1 = {0,0,0,0,0};
  static Brik liv = new Brik(x1,y1,1);

  static int[] x2 = {0,0,1,0,1};
  static int[] y2 = {0,0,0,1,1};
  static Brik katrine = new Brik(x2,y2,2);

  static int[] x3 =  {0,0,0,0,1};
  static int[] y3 =  {0,0,1,2,1};
  static Brik randi = new Brik(x3,y3,3);

  static int[] x4 =  {0,0,0,1,1};
  static int[] y4 =  {0,1,2,0,1};
  static Brik britt = new Brik(x4,y4,4);

  static int[] x5 = {0,0,0,1,1};
  static int[] y5 = {0,0,1,1,2};
  static Brik kari = new Brik(x5,y5,5);

  static int[] x6= {0,0,0,0,1};
  static int[] y6 = {0,0,1,2,0};
  static Brik kjell = new Brik(x6,y6,6);

  static int[] x7 = {0,0,1,1,1};
  static int[] y7 = {0,0,0,1,2};
  static Brik hanne = new Brik(x7,y7,7);

  static Brik[] briks = {liv,katrine,randi,britt,kari,kjell,hanne};

  static Brik farveBrik,sortBrik;

  static int[] farve = {0,1,2,3,4,5,6,7};

  public Brik drej90(Brik brik) {
    int[] x90 = new int[5];
    int[] y90 = new int[5];

    x90[0] = brik.x[0];
    y90[0] = brik.y[0];

    for (int k=1; k<=4; k++) {
      x90[k] = -brik.y[k];
      y90[k] = brik.x[k];
    }
    Brik brik90 = new Brik(x90,y90,brik.farve);
    return brik90;
  }

  public void timerTic(TimerEvent timerEvent) {
    if (naesteSkridt()) {
      point = raekkeFyldtOpCheck();
      if (point>0) score = score + point;
      textField.setText(""+sek+" sek ; Score: "+score);
    }
    sek = (int)(tid*(double)(DELAY)/1000.);
    tid++;
    timer.run();
  }

  public void keyPressed(KeyEvent keyEvent){
    switch (keyEvent.getKeyCode()) {
      case KeyEvent.VK_UP: {
        sortBrik = assignBrik(farveBrik);
        sortBrik = drej90(sortBrik);
        if (!kollisioner(sortBrik)) {
          tegnBrik( farveBrik, 0);
          tegnBrik( sortBrik, farveBrik.farve);
          farveBrik = assignBrik(sortBrik);
        }
        break;
      }
      case KeyEvent.VK_LEFT: {
              sortBrik = assignBrik(farveBrik);
              sortBrik.x[0] = sortBrik.x[0]-1;
              if (!kollisioner(sortBrik)) {
                tegnBrik( farveBrik, 0);
                tegnBrik( sortBrik, farveBrik.farve);
                farveBrik = assignBrik(sortBrik);
              }
              break;
      }
      case KeyEvent.VK_RIGHT: {
              sortBrik = assignBrik(farveBrik);
              sortBrik.x[0] = sortBrik.x[0]+1;
              if (!kollisioner(sortBrik)) {
                tegnBrik( farveBrik, 0);
                tegnBrik( sortBrik, farveBrik.farve);
                farveBrik = assignBrik(sortBrik);
              }
              break;
      }
      case KeyEvent.VK_DOWN: {
              Brik brik = new Brik();
              brik = assignBrik(farveBrik);
              do {
                sortBrik = assignBrik(brik);
                brik.y[0] = brik.y[0]-1;
              }
              while(!ramtBund(brik));
              tegnBrik( farveBrik, 0);
              farveBrik = assignBrik(sortBrik);
              tegnBrik( farveBrik, farveBrik.farve);
              for (int k=1; k<=4; k++)  {
                int brikX = farveBrik.x[k]+farveBrik.x[0];
                int brikY = farveBrik.y[k]+farveBrik.y[0];
                felt[brikY][brikX] = farveBrik.farve;
              }
              farveBrik = nyBrik();
              point = raekkeFyldtOpCheck();
              if (point>0) score = score +point;
              textField.setText(""+sek+" sek ; Score: "+score);
              tid++;
              sek = (int)(tid*(double)(DELAY)/1000);
              break;
      }
      case KeyEvent.VK_ENTER: timer.run();
    }
  }

  public void keyTyped(KeyEvent keyEvent) {
  }

  public void keyReleased(KeyEvent keyEvent){
  }

  public Brik assignBrik(Brik brik) {
    Brik assignbrik = new Brik();
    for (int k=0; k<=4; k++) {
      assignbrik.x[k] = brik.x[k];
      assignbrik.y[k] = brik.y[k];
    }
    assignbrik.farve = brik.farve;
    return assignbrik;
  }

  public void tegnFelt(int x0, int y0, int farve) {
    graphics=this.getGraphics();
    switch (farve) {
      case 0: graphics.setColor(Color.black); break;
      case 1: graphics.setColor(Color.magenta); break;
      case 2: graphics.setColor(Color.red); break;
      case 3: graphics.setColor(Color.green); break;
      case 4: graphics.setColor(Color.blue); break;
      case 5: graphics.setColor(Color.gray); break;
      case 6: graphics.setColor(Color.orange);  break;
      case 7: graphics.setColor(Color.yellow);
    }
    graphics.fillRect(x0*D,HEIGHT-y0*D,D,D);
  }

  public void tegnBrik(Brik brik, int farve) {
      for (int k=1; k<=4; k++) {
        int brikX = brik.x[0]+brik.x[k];
        int brikY = brik.y[0]+brik.y[k];
        tegnFelt(brikX,brikY,farve);
      }
  }

  public Brik nyBrik() {
    Brik brik = new Brik();
    brik = assignBrik(briks[(int)(Math.random()*7)]);
    brik.x[0] = (int)(Math.random()*5+2);
    brik.y[0] = ymax-2;
    return brik;
  }

  public boolean kollisioner(Brik brik) {
    boolean kollision=false;
    int k=1;
    while ((!kollision)&&(k<=4)) {
      int brikX = brik.x[k]+brik.x[0];
      int brikY = brik.y[k]+brik.y[0];
      if (brikY<ymax-2) {
        kollision = (brikX < 0)||(brikX > xmax);
        if (!kollision) kollision=(felt[brikY][brikX]!=0);
      }
      k++;
    }
    return kollision;
  }

  public boolean ramtBund(Brik brik) {
    boolean ramt=false;
    int k=1;
      while ((!ramt)&&(k<=4)) {
        int brikX = brik.x[k]+brik.x[0];
        int brikY = brik.y[k]+brik.y[0];
        if (brikY<=ymax) {
          ramt = (brikY<0);
          if (!ramt) ramt = felt[brikY][brikX]!=0;
        }
        k++;
      }
    return ramt;
  }

  public boolean raekkeTom(int[] raekke) {
    boolean tom=true;
    int k=0;
    while (tom && (k<=xmax)) {
      tom = raekke[k]==0; k++;
    }
    return tom;
  }

  public int raekkeFyldtOpCheck( ) {
    boolean tomRaekke,fyldtRaekke;
    int point=0;
    int x=0, y=0;

    do  {
      fyldtRaekke=true;
      tomRaekke=false;
      x=0;
      while (fyldtRaekke && (x<=xmax)) {
        fyldtRaekke = (felt[y][x]!=0);
        x++;
      }
      if (fyldtRaekke) {
        point+=100;
        int y0=y;
        do {
          for(x=0; x<=xmax; x++) {
            felt[y0][x] = felt[y0+1][x];
            tegnFelt(x,y0,felt[y0][x]);
          }
          y0++;
        }
        while (!raekkeTom(felt[y0]));
        y--;
      }
      else {
        x=0;
        tomRaekke=true;
        while (tomRaekke && (x<=xmax)) {
          tomRaekke = (felt[y][x]==0);
          x++;
        }
      }
      y++;
    }
    while (!tomRaekke);
    return point;
  }

  public boolean naesteSkridt( ) {
    boolean kontakt=false;
    sortBrik = assignBrik(farveBrik);
    sortBrik.y[0]--;
    if (!ramtBund(sortBrik)) {
      tegnBrik( farveBrik, 0);
      farveBrik = assignBrik(sortBrik);
      tegnBrik( farveBrik, farveBrik.farve);
    }
    else {
      for (int k=1; k<=4; k++) {
        int brikX = farveBrik.x[k]+farveBrik.x[0];
        int brikY = farveBrik.y[k]+farveBrik.y[0];
        felt[brikY][brikX] = farveBrik.farve;
      }
      kontakt = true;
      farveBrik = nyBrik();
    }
    if (!raekkeTom(felt[ymax])) System.exit(0);
    return kontakt;
  }

  public void init() {
    textField = new TextField("Tid:0   Score: 0");
    this.add(textField, BorderLayout.SOUTH);
    textField.addKeyListener(this);
    timer = new Timer(DELAY);
    TimerEvent timerEvent = new TimerEvent(timer);
    timer.addTimerListener(this);
  }

  public void paint(Graphics graphics) {
    this.graphics = graphics;
    if (start) {
      for (int y=0; y<=ymax; y++) {
        for (int x=0; x<=xmax; x++) {
          felt[y][x]=0;
          tegnFelt(x,y,felt[y][x]);
        }
      }
      farveBrik = nyBrik();
      sortBrik = new Brik();
      naesteSkridt();
      textField.setText("Tid:0 Score: 0");
      start=false;
    }
    textField.requestFocus();
  }
}

interface TimerListener extends EventListener {
  public void timerTic(TimerEvent timerEvent);
}

class TimerEvent extends AWTEvent {
  public static final int TIMER_EVENT = AWTEvent.RESERVED_ID_MAX+5555;

  public TimerEvent(Timer timer) {
    super(timer,TIMER_EVENT);
  }
}

class Timer extends Component implements Runnable {
  private int delay;
  private TimerListener listener;
  private static EventQueue eventQueue;

  public Timer(int delay) {
    this.delay=delay;

    Thread timerThread = new Thread(this);
    timerThread.start();
  }

  public void addTimerListener(TimerListener timerListener) {
    listener=timerListener;
  }

  public void run() {
    EventQueue eventQueue = Toolkit.getDefaultToolkit().getSystemEventQueue();
    TimerEvent timerEvent=new TimerEvent(this);
    eventQueue.postEvent(timerEvent);
    try {
      Thread.sleep(delay);
    }
    catch(InterruptedException e) {
      processEvent(timerEvent);
    }
    processEvent(timerEvent);
  }

  public void processEvent(AWTEvent evt) {
    if (evt instanceof TimerEvent) {
      if (listener!=null) listener.timerTic((TimerEvent)evt);
    }
    else super.processEvent(evt);
  }
}

class Brik {
  int[] x = new int[5];
  int[] y = new int[5];
  int farve;
  Brik() {}
  Brik(int[] x, int[] y, int farve) {
    this.x = x; this.y = y; this.farve = farve;
  }
}







